#!/usr/bin/env python
import os
import sys
import re
import copy

directory = sys.argv[1]
fichierSortie = open(sys.argv[2],'w')
fichiers = os.listdir(directory)

numCat = int(sys.argv[3])
numIn = int(sys.argv[4])
numOut = int(sys.argv[5])
beginData = 200
deltaEndData = 100

dataTot=[]
for fichier in fichiers:
    fichierEntree = open(directory+"/"+fichier,'r')
    lignes = fichierEntree.readline().split("\r")
    numLignes = (len(lignes)/numCat)*numCat
    ligne1 = re.findall('\d+',lignes[0])
    labels = ""
    for label in ligne1[1:]:
        if int(label)==0:
            label="-1"
        labels += label+" "
    ite = 0
    string = ""
    for ligne in lignes[beginData:numLignes-deltaEndData]:
        nums = re.findall('(\d+.\d*)|\d+',ligne)
        ite=ite+1
        data = nums[1:]
        for value in data:
            string += value+" "
        if (ite==numCat):
            dataTot.append(string)
            dataTot.append(labels)
            ite = 0
            string = ""

fichierSortie.write(str(len(dataTot)/2) + " " + str(numIn*numCat) + " "+ str(numOut) + "\n")
for data in dataTot:
    fichierSortie.write(data + "\n");
