//grainDynamique.js
//permet de génèrer une synthèse granulaire selon différents paramètres proposer à l'utilisateur

// nombre d'entrées du programme javascript
inlets = 2;
//nombre de sortie du programme javascript
outlets = 2;

// variables globales
var numsliders = 0;
var seqcounter = 0;
var thereverse = 0;
var thevalues = new Array(128);

// objets Max
var replace;
var biquad;
var dac2PIM;
var initialisation;
var envoiSon
var affichage;
var inverse;
var param;
var syntheseGranulaire;
var nbGrain;
var dac;
var dac2;
var dac6;
var on_off;
var on_offbis;
var volume;
var random;
var transposition;
var randombis;
var loadbang;
var nbSorties;
var lienDac;
var acquisitionWiimote;
var acquisitionNunchuk;
var numWii;
var port;
var rescaling;
var somme;
var amplifier;
var tailleFenetre;
var tailleSon;
var filtrage;
var unpack;
var ssmapping;
var borneInf;
var borneSup;
var sortieWav1;
var sortieWav2;
var filtre1;
var filtre2;
var boutonStop;
var pitch;
var retourRandom;
var retourRandom2;
var sorties = new Array(128);
// agencement -- construit le squelette de la synthèse granulaire
function agencement(val)
{
    if(arguments.length)
    {
        // stockage des arguments
        a = arguments[0];

        // sécurité en cas de mauvaise utilisation par l'utilisateur
        if(a<0) 
        a = 0;
        if(a>128) 
        a = 128;

    //suppression des objets statiques créés
        if(numsliders) 
    {
        this.patcher.remove(replace);
            this.patcher.remove(initialisation);
        
            this.patcher.remove(inverse);
            this.patcher.remove(syntheseGranulaire);
            this.patcher.remove(nbGrain);
            this.patcher.remove(dac);
            this.patcher.remove(volume);
            this.patcher.remove(on_off);
            this.patcher.remove(on_offbis);
            this.patcher.remove(random);    
            this.patcher.remove(transposition);     
            this.patcher.remove(randombis);   
          
            this.patcher.remove(lienDac);
            this.patcher.remove(nbSorties);  
            this.patcher.remove(borneInf);
            this.patcher.remove(borneSup);
            this.patcher.remove(rescaling);      
             this.patcher.remove(tailleSon);
             this.patcher.remove(tailleFenetre);        
             this.patcher.remove(amplifier);
             this.patcher.remove(somme);           
             this.patcher.remove(retourRandom);
             this.patcher.remove(retourRandom2);             
             this.patcher.remove(envoiSon);
            this.patcher.remove(sortieWav1);
            this.patcher.remove(sortieWav2);
            this.patcher.remove(filtre1);
            this.patcher.remove(filtre2);
            this.patcher.remove(boutonStop);
            this.patcher.remove(pitch);   
            this.patcher.remove(biquad);   
                
            }

        numsliders = a; // mise à jour de l'argument
        //construction des objets Max nécessaires à la synthèse granulaire
        if(numsliders) 
    { 
           
            replace = this.patcher.newdefault(350,40, "receive","#1_PF.WII.MoteurAudio.Grain.choisirSon");
            envoiSon = this.patcher.newdefault(350,100,"send","#1_PF.WII.MoteurAudio.Grain.EnvoiSon"); 
            
            initialisation = this.patcher.newdefault(350, 70, "pf.intel.toolbox.initialisation");
            tailleFenetre = this.patcher.newdefault(100,140, "receive","#1_PF.WII.MoteurAudio.Grain.tailleFenetre");    
            tailleSon = this.patcher.newdefault(540,120, "message");
            tailleSon.set("$1");
            amplifier = this.patcher.newdefault(100,170, "*",1000.);
            rescaling =  this.patcher.newdefault(200,170, "zmap",0.0,1.0,0.0 );
            rescaling.varname = "zmap";
            somme = this.patcher.newdefault(200,220, "+",0.0);
            borneInf = this.patcher.newdefault(100,250,"send","#1_PF.WII.MoteurAudio.Grain.BorneInf");
            borneSup = this.patcher.newdefault(350,250,"send","#1_PF.WII.MoteurAudio.Grain.BorneSup");
            sortieWav1 = this.patcher.newdefault(100,280,"receive","#1_PF.WII.MoteurAudio.Grain.sortieWave1");
             sortieWav2 = this.patcher.newdefault(400,280,"receive","#1_PF.WII.MoteurAudio.Grain.sortieWave2");           
         
            inverse = this.patcher.newdefault(200,320,"!-",0);
            syntheseGranulaire = this.patcher.newdefault(200,470,"pf.moteur.audio.grain.syntheseGranulaireDynam")
            nbGrain = this.patcher.newdefault(100,400,"receive","#1_PF.WII.MoteurAudio.Grain.nbrGrain");
            dac = this.patcher.newdefault(200,570,"pf.moteur.audio.grain.dacDynam");
            volume = this.patcher.newdefault(50,450,"receive","#1_PF.WII.MoteurAudio.Grain.volume");    
            on_off = this.patcher.newdefault(50,350,"receive","#1_PF.WII.MoteurAudio.Grain.OnOffGrain");
            on_offbis = this.patcher.newdefault(20,380,"receive","#1_PF.WII.MoteurAudio.Grain.OnOffDacRetour");
      
        
            randombis =    this.patcher.newdefault(650,420,"receive","#1_PF.WII.MoteurAudio.Grain.Random3");
            biquad = this.patcher.newdefault(200,650,"pf.moteur.audio.grain.biquadCascade");
            biquad.varname = "biquad"
            nbSorties = this.patcher.newdefault(250, 500, "receive","#1_PF.WII.MoteurAudio.Grain.nbrSortie");
            lienDac = this.patcher.newdefault(100,530,"receive","#1_PF.WII.MoteurAudio.Grain.connectSorties");
            filtre1 = this.patcher.newdefault(50,600,"receive","#1_PF.WII.MoteurAudio.Grain.sortie1");
            filtre2 = this.patcher.newdefault(350,600,"receive","#1_PF.WII.MoteurAudio.Grain.sortie2");
         
           
            retourRandom = this.patcher.newdefault(10,420,"receive","#1_PF.WII.MoteurAudio.Grain.RandomRetour");
            retourRandom2 = this.patcher.newdefault(320,420,"receive","#1_PF.WII.MoteurAudio.Grain.RandombisRetour");
             this.patcher.connect(numWii, 0, acquisitionWiimote, 0);
             this.patcher.connect(port, 0, acquisitionWiimote, 1);
             this.patcher.connect(acquisitionWiimote, 20, acquisitionNunchuk, 0);
              this.patcher.connect(initialisation, 1, tailleSon, 0);
              this.patcher.connect(tailleSon, 0, rescaling, 4);  
              this.patcher.connect(acquisitionNunchuk, 1, rescaling, 0);
             this.patcher.connect(rescaling, 0, somme, 0);
               this.patcher.connect(rescaling, 0, affichage, 2);        
             this.patcher.connect(somme, 0, affichage, 3);
             this.patcher.connect(tailleFenetre, 0, amplifier, 0);
             this.patcher.connect(amplifier, 0, somme, 1);
            this.patcher.connect(replace, 0, initialisation, 0);    
            
            this.patcher.connect(nbGrain,0,syntheseGranulaire,0);
            this.patcher.connect(nbGrain,0,dac,0);
            this.patcher.connect(loadbang,0,randombis,0);
            this.patcher.connect(nbSorties,0,dac,1);
            this.patcher.connect(lienDac,0,dac,2);
            this.patcher.connect(acquisitionNunchuk,0,filtrage,2);
            this.patcher.connect(acquisitionNunchuk,2,unpack,0);
            this.patcher.connect(acquisitionNunchuk,3,on_offbis,0);
           
            this.patcher.connect(filtre1,0,biquad,1);
            this.patcher.connect(filtre2,0,biquad,3);
          
            
            this.patcher.connect(initialisation,0,envoiSon,0);
            this.patcher.connect(rescaling,0,borneInf,0);
            this.patcher.connect(somme,0,borneSup,0);
            this.patcher.connect(sortieWav1,0,inverse,0);
             this.patcher.connect(sortieWav2,0,inverse,1);
            
        } 
        ourself = this.box; // assigne un objet max à notre objet javascript
      
    }
}



//liens -- construit les liens entre les objets max créé précédement
function liens(val)
{
    if(arguments.length)
    {
        b = arguments[0];

        if(b<0) 
        b = 0;
        if(b>128) 
        b = 128; 
       
        //suppression des liens entre les différents éléments
        if(numsliders) 
    {
            i=5;
            j=0;
            this.patcher.disconnect(on_off,0,syntheseGranulaire,0);
            this.patcher.disconnect(affichage,2,syntheseGranulaire,1);    
            this.patcher.disconnect(retourRandom,0,syntheseGranulaire,2);
            this.patcher.disconnect(inverse,0,syntheseGranulaire,3);
            this.patcher.disconnect(retourRandom2,0,syntheseGranulaire,4);
            this.patcher.disconnect(randombis,0,syntheseGranulaire,5);
            this.patcher.disconnect(volume,0,dac,3);
            this.patcher.disconnect(on_offbis,0,dac,4);
            while(j<a)
        {
                this.patcher.disconnect(syntheseGranulaire,j,dac,i);
                i=i+1;
                j=j+1;
            }
        } 
        numsliders = b; // mise à jour de l'argument
        //construction des liens entre les éléments
        if(numsliders) 
    { 
            i=5; //commence à 5 car les 5 première entrées de synthese granulaire sont fixes
            j=0;
            this.patcher.connect(on_off,0,syntheseGranulaire,1);
            this.patcher.connect(sortieWav1,0,syntheseGranulaire,2);    
            this.patcher.connect(retourRandom,0,syntheseGranulaire,3);
            this.patcher.connect(inverse,0,syntheseGranulaire,4);
            this.patcher.connect(retourRandom2,0,syntheseGranulaire,5);
            this.patcher.connect(randombis,0,syntheseGranulaire,6);
            this.patcher.connect(volume,0,dac,3);
            this.patcher.connect(on_offbis,0,dac,4);
            this.patcher.connect(dac,0,filtrage,0);
             this.patcher.connect(dac,1,filtrage,1);
         
            while(j<a)
        { 
                if(i==7 && i==10)//l'entrée 7 et 10 est prise par des entrées fixes quand le script est activé en attendant d'eventuelle correction nous procéderons ainsi
        {
            i=i+1;
        }             
                this.patcher.connect(syntheseGranulaire,j,dac,i);
                i=i+1;
                j=j+1;
            } 
        k=0;
        o=0;
            while(k<a)
        { 
               if(k%2==0){
                this.patcher.connect(dac,o,biquad,k);
                o=o+1;
               k=k+1;}
               k=k+1; 
            } 
          }       
        ourself = this.box;
    }
}